<script setup>
import { ref } from 'vue'

defineProps({
  serverName: String
})

let history = ref("")
let serverStatusText = ref("Unknown")
let serverStatusClass = ref("server-status-Unknown")
let serverApplicationStatusText = ref("Unknown")
let serverApplicationStatusClass = ref("server-status-Unknown")
let responseMessage = ref("")
let responseCode = ref(0)

function analyseServerResponse(serverResponse) {
  console.log("ServerManager | analyseServerResponse | serverResponse = ", serverResponse);
  responseMessage.value = serverResponse.message;
  responseCode.value = serverResponse.code;
  var previousHistory = history.value;
  history.value = responseCode.value + " | " + responseMessage.value + "\n" + previousHistory;
}

function analyseStatusServerResponse(serverResponse) {
  analyseServerResponse(serverResponse);
  if (responseCode.value == 0) {
    serverStatusText.value = responseMessage.value;
    serverStatusClass.value = "server-status-" + serverStatusText.value;
  }
}
function analyseStatusServerApplicationResponse(serverResponse) {
  analyseServerResponse(serverResponse);
  if (responseCode.value == 0) {
    serverApplicationStatusText.value = responseMessage.value;
    serverApplicationStatusClass.value = "server-status-" + serverApplicationStatusText.value;
  }
}

async function getFromAPI(url, callback) {
  var obj;
  await fetch(url)
    .then(res => res.json())
    .then(data => obj = data)
    .then(() => callback(obj));
}

const getServerStatus = async function () {
  await getFromAPI('status', analyseStatusServerResponse);
}
const startServer = async function () {
  await getFromAPI('start', analyseServerResponse);
}
const stopServer = async function () {
  await getFromAPI('stop', analyseServerResponse);
}
const resetServer = async function () {
  await getFromAPI('reset', analyseServerResponse);
}
const getApplicationStatus = async function () {
  await getFromAPI('applicationStatus', analyseStatusServerApplicationResponse);
}

</script>

<template>
<div id="server-status" v-bind:class="serverStatusClass">Server {{ serverStatusText }}</div>
<div id="server-application" v-bind:class="serverApplicationStatusClass">Minecraft {{ serverApplicationStatusText }}
</div>
<div class="server-header">
    <img v-bind:alt="serverName" src="../assets/DELL_R620.png" class="img-fluid"/>
    <h1>{{ serverName }}</h1>
    <hr/>
</div>
<img
    id="img-clickable"
    alt="Status Server"
    src="../assets/system_status.png"
    class="img-fluid"
    @click="getServerStatus"
/>
<img
    id="img-clickable"
    alt="Start Server"
    src="../assets/system_start.png"
    class="img-fluid"
    @click="startServer"
/>
<img
    id="img-clickable"
    alt="Stop Server"
    src="../assets/system_stop.png"
    class="img-fluid"
    @click="stopServer"
/>
<img
    id="img-clickable"
    alt="Reset Server"
    src="../assets/system_reset.png"
    class="img-fluid"
    @click="resetServer"
/>
<img
    id="img-clickable"
    alt="Minecraft Application Server Status"
    src="../assets/application_minecraft.png"
    class="img-fluid"
    @click="getApplicationStatus"
/>
<div class="history">
    <p>
        <strong>History</strong>
    </p>
    <pre>{{ history }}
    </pre>
</div>
</template>

<style scoped>
#img-clickable {
  cursor: pointer;
}
#server-status {
  position: absolute;
  left: 25%;
  top: 10%;
  width: 200px;
  text-align: center;
  padding: 0 20px;
  border-radius: 30px;
  line-height: 30px;
  font-size: 17px;
  color: white;
  font-family: Trebuchet, Arial, sans-serif;
  font-weight: bold;
  box-sizing: border-box;
}
#server-application {
  position: absolute;
  left: 25%;
  top: 20%;
  width: 200px;
  text-align: center;
  padding: 0 20px;
  border-radius: 30px;
  line-height: 30px;
  font-size: 17px;
  color: white;
  font-family: Trebuchet, Arial, sans-serif;
  font-weight: bold;
  box-sizing: border-box;
}
.history {
  position: relative;
  text-align: center;
  padding: 0 20px;
  border-radius: 30px;
  font-size: 12px;
  color: black;
  font-family: Trebuchet, Arial, sans-serif;
  font-weight: bold;
  box-sizing: border-box;
}
.server-status-Stopped {
  background: #cc3333;
}
.server-status-Started {
  background: #22be37;
}
.server-status-Unknown {
  background: #1c2669;
}
</style>
